CountersActivity subclass: #ActivationActivity
	instanceVariableNames: 'currentActivation reevaluationSemaphore '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Actalk-Synchro-Activation'!


!ActivationActivity methodsFor: 'initialize'!

privateInitialize
	super privateInitialize.
	reevaluationSemaphore := Semaphore new! !

!ActivationActivity methodsFor: 'activity setting'!

body
	"Define the behavior body."

	| i mailBox|
	mailBox := self mailBox.
	[true] whileTrue:
		[i := 1.
		[i <= (mailBox size)] whileTrue:
			[currentActivation := mailBox at: i.
			(self isAcceptableMessage: currentActivation)
				ifTrue:
					[mailBox removeAtIndex: i.
					self acceptMessage: currentActivation].
			i := i + 1].
		reevaluationSemaphore wait;
			initSignals]! !

!ActivationActivity methodsFor: 'synchro events'!

synchroEventAccept: aMessage
	super synchroEventAccept: aMessage.
	reevaluationSemaphore signal!

synchroEventComplete: aMessage
	super synchroEventComplete: aMessage.
	reevaluationSemaphore signal!

synchroEventReceive: aMessage
	super synchroEventReceive: aMessage.
	reevaluationSemaphore signal! !

!ActivationActivity methodsFor: 'guard constructs'!

messageOrderingPreservationFor: selector
	^self noActivationWith: [:activation |
			activation selector = selector
				and: [activation arrivalTime < currentActivation arrivalTime]]!

noActivationWith: aBlock
	^(self mailBox contents detect: aBlock ifNone: [nil]) isNil! !

!ActivationActivity methodsFor: 'default classes'!

activationClass
	^Activation!

addressClass
	^ActivationAddress! !

SynchroConcurrentAddress subclass: #ActivationAddress
	instanceVariableNames: 'arrivalCounter '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Actalk-Synchro-Activation'!


!ActivationAddress methodsFor: 'initialize'!

privateInitialize
	super privateInitialize.
	arrivalCounter := 0! !

!ActivationAddress methodsFor: 'message passing'!

asynchronousSend: aMessage inMessageQueue: queue
	"Create and enqueue a new time stamped invocation for the newly arrived message.
	Ensure that asynchronous send (actual enqueueing of the message)
	AND the receive synchronization event are atomic."

	| messageActivation |
	activity synchroMutualExclusion critical:
		[arrivalCounter := arrivalCounter + 1.
		messageActivation := (activity activationClass new
								setSelector: aMessage selector arguments: aMessage arguments;
								replyTo: aMessage replyTo;
								arrivalTime: arrivalCounter).
		queue nextPut: messageActivation.
		activity synchroEventReceive: messageActivation].
	activity kernelEventReceive: messageActivation! !

ReplyToMessage subclass: #Activation
	instanceVariableNames: 'arrivalTime '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Actalk-Synchro-Activation'!


!Activation methodsFor: 'accessing'!

arrivalTime
	^arrivalTime!

arrivalTime: anInteger
	arrivalTime := anInteger! !
